"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = __importStar(require("path"));
const boa = require('@pipcook/boa');
const { tuple } = boa.builtins();
const sys = boa.import('sys');
// TODO(Feely): support dot in the module name
sys.path.insert(0, path.join(__dirname, '..'));
const { CycleGAN } = boa.import('CycleGAN.models');
let opt = {
    shapeA: tuple([128, 128, 3]),
    shapeB: tuple([128, 128, 3]),
    // scale images to this size
    resize: tuple([143, 143]),
    // then crop to this size
    crop: tuple([128, 128]),
    /**
     * net definition
     */
    // selects model to use for netD
    which_model_netD: 'basic',
    // selects model to use for netG
    which_model_netG: 'resnet_6blocks',
    // if 1, use least square GAN, if 0, use vanilla GAN
    use_lsgan: 1,
    //  of gen filters in first conv layer
    ngf: 64,
    // of discrim filters in first conv layer
    ndf: 64,
    lmbd: 10.0,
    idloss: 1.0,
    /**
     * optimizers
     */
    // initial learning rate for adam
    lr: 0.0002,
    // momentum term of adam
    beta1: 0.5,
    // model file
    recoverPath: ''
};
const cycleGanModelDefine = (data, args) => __awaiter(void 0, void 0, void 0, function* () {
    opt = Object.assign(Object.assign({}, opt), args);
    const model = new CycleGAN(opt);
    const pipcookModel = {
        model,
        config: null,
        predict: function (inputData) {
            return model.predict(inputData.data.path, inputData.data.predictType);
        }
    };
    return pipcookModel;
});
exports.default = cycleGanModelDefine;
//# sourceMappingURL=index.js.map